/// @file

#if !defined cmif_StringFunctionParser_h
#define cmif_StringFunctionParser_h

#include <map>
#include <set>
#include <string>

/// Document the namespace
namespace cmif
{
		/// Example class for bug 658779
	struct StringFunctionParser
    {
			// No bug with these definitions
		//typedef std::set<double> Symbols;	///< Map of symbol values.
		//typedef std::set<std::string> StringSymbols; ///< Convenience definition of symbol string map

			// BUG with these definitions
		typedef std::map<std::string, double> Symbols;	///< Map of symbol values.
		typedef std::map<std::string, std::string> StringSymbols; ///< Convenience definition of symbol string map

		double evaluate(const Symbols& symbols);
		std::string evaluate(const StringSymbols& map);
    };
}

#endif // cmif_StringFunctionParser_h
